'''
Si vuole visualizzare una gerarchia di directory in modo grafico producendo una immagine PNG a forma di albero orizzontale.

Per visualizzare ciascun nome di file/directory si userà una codifica caratteri->componenti di colore.

Si assume che il nome del file abbia sempre lunghezza al piu’ 30 
e che, per ogni carattere c del nome, il codice unicode (ottenibile tramite la funzione ord(c)) dia sempre un intero tra 0 e 255.

NOTA: Tutti i file o le directory che iniziano col carattere '.' devono essere ignorati.

Stando cosi le cose il nome viene trasformato in una sequenza di 10 pixel nel seguente modo:
- si trasforma in una lista interi il testo utilizzando la funzione ord carattere per carattere.
- se la lista risulta avere meno di 30 elementi viene portata a 30 interi aggiungendo degli 0 in fondo.
- si codifica ciascuna tripletta ABC di interi  consecutivi in un colore con componenti (A, B, C)

Esempio:    'Paperino.txt'
in interi:  [80, 97, 112, 101, 114, 105, 110, 111, 46, 116, 120, 116] + [0]*18
in colori:  [(80, 97, 112), (101, 114, 105), (110, 111, 46), (116, 120, 116)] + [(0, 0, 0)]*6

L'albero delle directory viene rappresentato seguendo queste regole:
- la radice è posizionata a coordinate 0,0 (quindi occupa i primi 10 pixel della prima linea)
- se un nodo è una directory ed ha figli:
    - i corrispondenti sottoalberi vengono visualizzati uno sotto l'altro in ordine crescente alfabetico delle radici dei sottoalberi
    - il nodo è collegato al primo figlio da una linea bianca orizzontale di 10 pixel
    - i figli successivi sono raggiunti da una linea spezzata
        - 5 pixel orizzontali (ovvero la metà della linea che collega al primo figlio)
        - tanti pixel verticali quanti ne sevono ad arrivare al prossimo figlio
        - 5 pixel orizzontali per arrivare al prossimo figlio
    - L'altezza totale di un sottoalbero è la somma delle altezze dei sottoalberi
        lasciando uno spazio di 1 pixel tra ciascun sottoalbero
- se un nodo è una foglia viene disegnato con i suoi 10 pixel
    l'altezza del disegno della foglia è di 1 pixel

Vedete l'esempio in Informatica.png che rappresenta la sottodirectory dirs/Informatica

L'immagine da produrre e salvare deve avere:
    - larghezza sufficiente a contenere tutto l'albero
        (con 10 pixel per ogni nome e 10 pixel di separazione tra ciascun livello)
    - altezza pari all'altezza sufficiente a contenere tutto l'albero
    - sfondo nero (0,0,0)

Implementare la funzione es3(path, filePNG) che (se necessario usando altre funzioni, oggetti o metodi):
    - esplora la gerarchia di directory che parte dalla directory path
    - se necessario costruisce un albero che potete implementare come oggetti
    - costruisce una immagine come lista di liste di triple con il disegno dell'albero
    - la salva nel file filePNG
    - torna come risultato la coppia (larghezza, altezza) della immagine

NOTA: Il timeout per ciascun test per questo esercizio è di 4 secondi.

ATTENZIONE: Almeno una delle funzioni/metodi che risolvono l'esercizio DEVE essere ricorsiva.
ATTENZIONE: per fare in modo che il macchinario di test riconosca automaticamente la presenza della ricorsione
    questa funzione ricorsiva DEVE essere una funzione esterna oppure il metodo di una classe.

ATTENZIONE: Non potete usare altre librerie a parte os, os.path e immagini.

ATTENZIONE: è VIETATO usare la funzione di libreria os.walk

ATTENZIONE: assicuratevi di salvare il programma con encoding utf8
(ad esempio usando come editor Notepad++ oppure Spyder)
'''

import immagini, os, os.path

def es3(path, filePNG):
    # inserite qui il vostro codice
    pass






# le righe seguenti non vengono eseguite se il modulo viene importato
if __name__ == '__main__':
    # inserite qui i vostri test personali
    pass
